/* Copyright 1995 by Shay Cohen.
 * All rights reserved
 *
 * You may distribute this program freely, under some circumstances:
 * You may not remove my name from the source or documentation, mark
 * your changes if you make ones, don't change or remove this notice.
 * I am not responsible for any possible damage caused by this program,
 * and the responsiblty rests entirely with the user.
 *
 * You can reach me for bug reports, suggestions, comments and life
 * threats as follows:
 * InterNet - shay@aquanet.co.il.
 * FidoNet - 2:403/423 (Shay Cohen).
*/

#include <time.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "config.h"
#include "fido.h"
#include "misc.h"

struct fidoaddress myfidoaddr;
struct fidoaddress fakefidoaddr;

char DefaultUsenetFolder[40];
char Emailaddr[80];
char mytimezone[6];
char myNEWSGROUPSFILE[80];
char postpktfile[80];
char writepktfile[80];
char fromalonefolder[80];
char fidoaddrstr[20];
char servername[50];
char originline[70];

int error=0; 


closefidopacket(filename)
char *filename;
{
 FILE tf,*f=&tf;
 char nullchar = 0;

 f=fopen(filename,"a");
 if (f==NULL)
 {
  fprintf(stderr,ERROR_PKTCLOSE);
  return -1;
 }
 fwrite(&nullchar,1,1,f);
 fwrite(&nullchar,1,1,f);

 fclose(f);
 return(0);
}

readsetup()
{
 FILE tf,*f=&tf;
 char filename[80];
 strcpy(filename,getenv("HOME")); strcat(filename,"/.usepktrc");
 f=fopen(filename,"r");
 if (f==NULL) 
 { 
  fprintf(stderr,"Cannot open setup file (.usepktrc)!\n");
  exit(2);
 }
 fgets(Emailaddr,sizeof(Emailaddr),f);
 Emailaddr[strlen(Emailaddr)-1]='\0';
 fgets(DefaultUsenetFolder,sizeof(DefaultUsenetFolder),f);
 DefaultUsenetFolder[strlen(DefaultUsenetFolder)-1]='\0';
 fgets(fromalonefolder,sizeof(fromalonefolder),f);
 fromalonefolder[strlen(fromalonefolder)-1]='\0';
 fgets(mytimezone,sizeof(mytimezone),f);
 mytimezone[strlen(mytimezone)-1]='\0';
 fgets(postpktfile,sizeof(postpktfile),f);
 postpktfile[strlen(postpktfile)-1]='\0';
 fgets(writepktfile,sizeof(writepktfile),f);
 writepktfile[strlen(writepktfile)-1]='\0';
 fgets(fidoaddrstr,sizeof(fidoaddrstr),f);
 myfidoaddr.zone=atoi(strtok(fidoaddrstr,":"));
 myfidoaddr.net=atoi(strtok(NULL,"/"));
 myfidoaddr.node=atoi(strtok(NULL,"\n"));
 fgets(fidoaddrstr,sizeof(fidoaddrstr),f);
 fakefidoaddr.zone=atoi(strtok(fidoaddrstr,":"));
 fakefidoaddr.net=atoi(strtok(NULL,"/"));
 fakefidoaddr.node=atoi(strtok(NULL,"\n"));
 fgets(servername,sizeof(servername),f);
 servername[strlen(servername)-1]='\0';
 fgets(originline,sizeof(originline),f);
 originline[strlen(originline)-1]='\0';
 printf("Your fido address is: %d:%d/%d\n",myfidoaddr.zone,myfidoaddr.net,myfidoaddr.node);
 printf("Bundling packets from node: %d:%d/%d\n",fakefidoaddr.zone,fakefidoaddr.net,fakefidoaddr.node);
 printf("Your internet address is: %s\n",Emailaddr);

 fclose(f);
 strcpy(myNEWSGROUPSFILE,getenv("HOME"));
 strcat(myNEWSGROUPSFILE,"/");
 strcat(myNEWSGROUPSFILE,NEWSGROUPSFILE);
}

main(argc,argv)
int argc;
char *argv[];
{
 int sock;

 readsetup();

 printf("Closing packet...\n"); 

 closefidopacket(writepktfile);
}
