/* Copyright 1995 by Shay Cohen.
 * All rights reserved
 *
 * You may distribute this program freely, under some circumstances:
 * You may not remove my name from the source or documentation, mark
 * your changes if you make ones, don't change or remove this notice.
 * I am not responsible for any possible damage caused by this program,
 * and the responsiblty rests entirely with the user.
 *
 * You can reach me for bug reports, suggestions, comments and life
 * threats as follows:
 * InterNet - shay@aquanet.co.il.
 * FidoNet - 2:403/423 (Shay Cohen).
*/

/* structure of packed fido message file: */
struct packedfidomsgheader {
         unsigned short msgType,
                       origNode,
                       destNode,
                       origNet,
                       destNet,
                       Attribute,
                       cost;
       };

/* structure of regular fido message file, not really used: */
struct fidomsgheader {
 char fromUserName[36];
 char toUserName[36];
 char subject[72];
 char DateTime[20];
 unsigned short timesRead,
              destNode,
              origNode,
              cost,
              origNet,
              destNet,
              destZone,
              origZone,
              destPoint,
              origPoint,
              replyTo,
              Attribute,
              nextReply;
};

/* structure of fido packets */
struct fidopacketheader {
unsigned short origNode,
               destNode,
               year,
               month,
               day,
               hour,
               minute,
               second,
               baud,
               pktType,
               origNet,
               destNet;
unsigned char  ProdCode,
               SerialNo;
unsigned char  password[7];
unsigned short origZone,
               destZone;
         char  fill[20];
};

/* structure of a fido address, used by UsePkt. points number are not used
   because they can't be used in fido packets anyway */
struct fidoaddress {
  unsigned short zone;
  unsigned short net;
  unsigned short node;
};
