/* Copyright 1995 by Shay Cohen.
 * All rights reserved
 *
 * You may distribute this program freely, under some circumstances:
 * You may not remove my name from the source or documentation, mark
 * your changes if you make ones, don't change or remove this notice.
 * I am not responsible for any possible damage caused by this program,
 * and the responsiblty rests entirely with the user.
 *
 * You can reach me for bug reports, suggestions, comments and life
 * threats as follows:
 * InterNet - shay@aquanet.co.il.
 * FidoNet - 2:403/423 (Shay Cohen).
*/

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "config.h"

int postallowed;
extern char myNEWSGROUPSFILE[80];
extern char myNEWSSUBJECTSFILE[80];
extern int checkrecover;

void addgrouptolist(f,groupstr,posting,directory,mytm)
FILE *f;
char *groupstr;
char *posting;
char *directory;
time_t mytm;
{
 char buf[BUFSIZE];
 time_t t;
 struct tm tmnow;

 if (mytm == 0) t=time(&t);
 else t=mytm;

 tmnow= *(localtime(&t));

 sprintf(buf,"%s:%.2d%.2d%.2d:%.2d%.2d%.2d:%s:%s",
  groupstr,tmnow.tm_year,tmnow.tm_mon+1,tmnow.tm_mday,
  tmnow.tm_hour,tmnow.tm_min,tmnow.tm_sec,posting,directory);

 fprintf(f,"%s\n",buf);
}



char *groupexists(f,newsgroup)
FILE *f;
char *newsgroup;
{
 char buf[BUFSIZE],*s,*s2;
 static char groupbuf[BUFSIZE];
 
 s2=newsgroup;
 fseek(f,0,SEEK_SET);
 if (newsgroup[0]=='*') s2++;
 while (fgets(groupbuf,80,f) != NULL)
 {
   if (rindex(groupbuf,':')!=NULL)
   {
    strcpy(buf,strtok(groupbuf,":"));
    s=buf;
    if (buf[0] == '*') s++;
    if (!strcmp(s2,s)) return groupbuf;
   }
 }
 return NULL;
}

char *foldertonewsgroup(folder)
char *folder;
{
 FILE *f;
 char *s, mybuf[BUFSIZE], foldername[40];
 static char groupname[200],posting[2];
 
 f=fopen(myNEWSGROUPSFILE,"r"); 
 if (f==NULL)
  { 
   fprintf(stderr,ERROR_GROUPSOPEN);
   return NULL;
  }
 while (fgets(mybuf,100,f) != NULL)
 {
 if ((rindex(mybuf,':') != NULL) && (mybuf[0]!='#'))
  {
   strcpy(groupname,strtok(mybuf,":")); 
   s=groupname;
   if (groupname[0]=='*') s++;
   strtok(NULL,":"); strtok(NULL,":"); strcpy(posting,strtok(NULL,":")); 
   strcpy(foldername,strtok(NULL,"\n"));
   if (!strcmp(folder,foldername))
   {
    fclose(f);
    if (posting=="n") postallowed=NOTALLOWED;
              else postallowed=ALLOWED;
    return(s);
   }
  }
 }
 fclose(f);
 return NULL;
}



/* Convert usenet date to fidonet date */
char *dateheader(s)
char *s;
{
 static char date[25];
 /*char m[50],buf2[50];*/
 time_t t;
 struct tm tmnow;
 char monthstr[12][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul",
                       "Aug","Sep","Oct","Nov","Dec"};


/* if (rindex(s,' ')!=NULL)
 {
 strcpy(m,index(s,' ')+1);
 strncpy(date,&m[5],9); date[9]=' '; date[10]=' '; date[2]=' '; date[6]=' ';
 strncpy(&date[11],&m[15],8);
 date[19] = '\0';
 }
 else*/
 strcpy(date,"=========");
 if ((date[2]!=' ') || (date[6]!=' ') || (date[9]!=' ') || (date[10]!=' '))
 {
 t=time(&t);
 tmnow=*(localtime(&t));
 sprintf(date,"%.2d %s %.2d  %.2d:%.2d:%.2d",
            tmnow.tm_mday,monthstr[tmnow.tm_mon],tmnow.tm_year,
            tmnow.tm_hour,tmnow.tm_min,tmnow.tm_sec);
 }
 return(date);
}



/* Get usenet header line, and return header name */
char *articleheader(s)
const char *s;
{
  static char headerbuf[BUFSIZE];
  char m[BUFSIZE]; 
  strcpy(m,s);
  strcpy(headerbuf,strtok(m,":"));
  return(headerbuf);
}


/* Get usenet from header, and return the e-mail address */
char *fromheader(s)
const char *s;
{
  static char headerbuf[BUFSIZE];
  char /*buf[BUFSIZE],buf2[BUFSIZE],*/ m2[BUFSIZE],*m; 
  
  strcpy(m2,s); m=m2; m+=6;

  /* From header is From: user@host */
  if ((rindex(m,' ')==NULL) || (rindex(m,'@')==NULL))
  {
   strcpy(headerbuf,m);
   if (strlen(headerbuf) > 35) headerbuf[35]='\0';
   return(headerbuf); 
  }

  /* user@host (User Name) */
  if (rindex(m,'(')!=NULL)
  {
   strncpy(headerbuf,m,strlen(m)-strlen(rindex(m,'('))-1);
   headerbuf[strlen(m)-strlen(rindex(m,'('))-1]='\0';
   if (strlen(headerbuf) > 35) headerbuf[35] = '\0';
   return(headerbuf);
  }


  /* User Name <host> */
  if (rindex(m,'<')!=NULL)
  {
  strncpy(headerbuf,rindex(m,'<')+1,strlen(rindex(m,'<'))-2);
  headerbuf[strlen(rindex(m,'<'))-2]='\0';
  if (strlen(headerbuf) > 35) headerbuf[35]='\0';
  return(headerbuf);
  }
 strcpy(headerbuf,m);
 return(headerbuf);
}

/*char *randomkludge()
{
 static char idbuf[61];
 char *s=idbuf;
 int i;

 *s++='(';
 for (i=1;i<10;i++)
 {
  idbuf[i] = (char)((rand() % (122-60))+65); s++;
 }
 *s++='@';
 *s='\0';
 *s++=')'; *s='\0';

 return idbuf;
}*/

char *randomkludge()
{
 static char idbuf[61];
 char *s=idbuf;
 int i;

 for (i=0;i<8;i++)
 {
  idbuf[i] = (char)((rand() % (9))+49); s++;
 }
 *s='\0';
 return idbuf;
}

#ifdef DEBUG
#define DBG1( cntrl, arg1 )   printf( cntrl, arg1 )
#else
#define DBG1( x, y ) 
#endif

char *subjectexists(subj)
char *subj;
{

 FILE *f;
 static char subjbuf[70],realsubj[70];
 char tempbuf[100],*tmp;

 DBG1( "shay %s", "kkk" );
 
 tempbuf[3]='\0';
 strncpy(tempbuf,subj,3);
 if (strcmp(tempbuf,"Re:"))
  strcpy(realsubj,subj);
 else strcpy(realsubj,&subj[4]);

 f=fopen(myNEWSSUBJECTSFILE,"r");
 if (f==NULL) return NULL;
 
 while (fgets(tempbuf,99,f)!=NULL)
 {
  if (strcmp(tempbuf,""))
  {
  strcpy(subjbuf,tempbuf);
  tmp=(char *)strstr(subjbuf,":-From-:");
  *tmp='\0'; tmp+=8;
  if (!strcmp(subjbuf,realsubj))
  {
  /* strtok(NULL,":");*/
   strcpy(realsubj,tmp);
   realsubj[strlen(realsubj)-2]=0;
   fclose(f);
   return realsubj;
  }
  } /* not blank */
 }

 fclose(f);
 return NULL;  
}

int addsubject(name,subj)
char *subj, *name;
{
 FILE *f;
 char temp[4],realsubj[80];
 
 strcpy(realsubj,subj);
 if (subjectexists(realsubj)!=NULL) return 0;

/* printf("%s\n",subjectexists(realsubj)); 
 printf("subject not found?\n");
*/
 f=fopen(myNEWSSUBJECTSFILE,"a");
 if (f==NULL) return 0;

 temp[3]='\0';
 strncpy(temp,subj,3);

 if (strcmp(temp,"Re:"))
  fprintf(f,"%s:-From-:%s*\n",subj,name);
 else
  fprintf(f,"%s:-From-:%s*\n",&subj[4],name);
 fclose(f);
 return 1;
}

int addrecoverentry(s)
char *s;
{
 FILE *f;

 f=fopen(RECOVERFILE,"a");
 if (f==NULL) return 0;
 fprintf(f,"%s",s);
 fclose(f);
 return 0;
}

int recoverfileexists()
{
 FILE *f;
 f=fopen(RECOVERFILE,"r");
 if (f==NULL) return 0;
 else {
   fclose(f);
   return 1;
  } 
}

int recoverentryexists(s)
char *s;
{
 FILE *f;
 char buf[80];
 
 if (!checkrecover) return 0;
 f=fopen(RECOVERFILE,"r");
 if (f==NULL) return 0;
 while (fgets(buf,80,f)!=NULL)
 {
  if (!strcmp(buf,s))
  {
   fclose(f);
   return 1;
  }
 }
 fclose(f);
 return 0;
}
