/* Copyright 1995 by Shay Cohen.
 * All rights reserved
 *
 * You may distribute this program freely, under some circumstances:
 * You may not remove my name from the source or documentation, mark
 * your changes if you make ones, don't change or remove this notice.
 * I am not responsible for any possible damage caused by this program,
 * and the responsiblty rests entirely with the user.
 *
 * You can reach me for bug reports, suggestions, comments and life
 * threats as follows:
 * InterNet - shay@aquanet.co.il.
 * FidoNet - 2:403/423 (Shay Cohen).
*/

/*
   Purpose: Grab the new news messages ids from the server.

   Parameters:
   socket - socket to use.
   newsgroup - newsgroup name to scan.
   date - scan since date (yymmdd).
   time - scan since time (hhmmss).

   Returns: -1 if failed, else number of new messages.
*/

extern int nntp_newnews(int socket, const char *newsgroup, const char *date, const char *time);

/*
   Purpose: Grab an article from the server, and output a fido message.

   Parameters:
   socket - socket to use.
   messageid - article's message-id.
   filename - fido message output filename.

   Returns: -1 if failed, else 0.
*/
extern int nntp_getarticle(int socket,char *messageid,char *filename);

extern int nntp_listgroups(int sock);

extern int nntp_getgroup(int sock,char *path,char *newsgroup,char *date,char *time);

extern int nntp_scangroups(int sock);
