/* Copyright 1995, 1996 by Shay Cohen.
 * All rights reserved
 *
 * You may distribute this program freely, under some circumstances:
 * You may not remove my name from the source or documentation, mark
 * your changes if you make ones, don't change or remove this notice.
 * I am not responsible for any possible damage caused by this program,
 * and the responsiblty rests entirely with the user.
 *
 * You can reach me for bug reports, suggestions, comments and life
 * threats as follows:
 * InterNet - shay@aquanet.co.il.
 * FidoNet - 2:403/423 (Shay Cohen).
*/

#include <time.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <sys/signal.h>
#include <stdlib.h>

#include "config.h"
#include "fido.h"
#include "misc.h"
#include "nntptalk.h"
#include "socket.h"
struct fidoaddress myfidoaddr;
struct fidoaddress fakefidoaddr;

char buf[BUFSIZE];
char DefaultUsenetFolder[40];
char Emailaddr[80];
char mytimezone[6];
char myNEWSGROUPSFILE[80];
char myNEWSSUBJECTSFILE[80];
char postpktfile[80];
char writepktfile[80];
char fromalonefolder[80];
char fidoaddrstr[20];
char servername[50];
char originline[70];
int lines_limit=0;
int bytes_limit=0;
int checkrecover;
int error=0; 


int openfidopacket(filename)
char *filename;
{
 FILE *f;
 struct fidopacketheader pktheader;
 struct tm tmnow;
 time_t t;
 
 t=time(&t);
 tmnow=*(localtime(&t));
 pktheader.origNode = fakefidoaddr.node;
 pktheader.destNode = myfidoaddr.node;
 pktheader.year = tmnow.tm_year+1900;
 pktheader.month = tmnow.tm_mon;
 pktheader.day = tmnow.tm_mday;
 pktheader.hour = tmnow.tm_hour;
 pktheader.minute = tmnow.tm_min;
 pktheader.second = pktheader.baud = 0;
 pktheader.pktType = 0x0002;
 pktheader.origNet = fakefidoaddr.net;
 pktheader.destNet = myfidoaddr.net;
 pktheader.destZone = myfidoaddr.zone;
 pktheader.origZone = fakefidoaddr.zone;
 strcpy(pktheader.password,"\0\0\0\0\0\0\0");
 pktheader.ProdCode = pktheader.SerialNo = 0;
 memset(&pktheader.fill,0,sizeof(pktheader.fill));

 f=fopen(filename,"w");
 if (f==NULL)
 {
  fprintf(stderr,ERROR_PKTCREAT);
  return -1;
 }


 fwrite(&pktheader,1,sizeof(pktheader),f);

 fclose(f);
 return 0;
}

int closefidopacket(filename)
char *filename;
{
 FILE *f;
 char nullchar = 0;

 f=fopen(filename,"a");
 if (f==NULL)
 {
  fprintf(stderr,ERROR_PKTCLOSE);
  return -1;
 }
 fwrite(&nullchar,1,1,f);
 fwrite(&nullchar,1,1,f);

 fclose(f);
 return(0);
}

char *setupfgets(s,i,f)
FILE *f;
int i;
char *s;
{
 char *tmp,tmpbuf[100];
 do
 {
  tmp=fgets(tmpbuf,100,f);
  if (tmp==NULL) { 
		printf(".usepktrc is misconfigured!\r\n");
		exit(0);
		return NULL;
		 }
 }
 while ((!strcmp(tmpbuf,"\n")) || (tmpbuf[0]=='#'));
 strcpy(s,tmpbuf);
 return tmp;
}

int readsetup()
{
 FILE *f;
 char filename[80], limits[80];

 strcpy(filename,getenv("HOME")); strcat(filename,"/.usepktrc");
 f=fopen(filename,"r");
 if (f==NULL) 
 { 
  fprintf(stderr,"Cannot open setup file (.usepktrc)!\n");
  exit(2);
 }
 setupfgets(Emailaddr,sizeof(Emailaddr),f);
 Emailaddr[strlen(Emailaddr)-1]='\0';
 setupfgets(DefaultUsenetFolder,sizeof(DefaultUsenetFolder),f);
 DefaultUsenetFolder[strlen(DefaultUsenetFolder)-1]='\0';
 setupfgets(fromalonefolder,sizeof(fromalonefolder),f);
 fromalonefolder[strlen(fromalonefolder)-1]='\0';
 setupfgets(mytimezone,sizeof(mytimezone),f);
 mytimezone[strlen(mytimezone)-1]='\0';
 setupfgets(postpktfile,sizeof(postpktfile),f);
 postpktfile[strlen(postpktfile)-1]='\0';
 setupfgets(writepktfile,sizeof(writepktfile),f);
 writepktfile[strlen(writepktfile)-1]='\0';
 setupfgets(fidoaddrstr,sizeof(fidoaddrstr),f);
 myfidoaddr.zone=atoi(strtok(fidoaddrstr,":"));
 myfidoaddr.net=atoi(strtok(NULL,"/"));
 myfidoaddr.node=atoi(strtok(NULL,"\n"));
 setupfgets(fidoaddrstr,sizeof(fidoaddrstr),f);
 fakefidoaddr.zone=atoi(strtok(fidoaddrstr,":"));
 fakefidoaddr.net=atoi(strtok(NULL,"/"));
 fakefidoaddr.node=atoi(strtok(NULL,"\n"));
 setupfgets(servername,sizeof(servername),f);
 servername[strlen(servername)-1]='\0';
 setupfgets(originline,sizeof(originline),f);
 originline[strlen(originline)-1]='\0';
 setupfgets(limits,sizeof(limits),f);
 lines_limit=atoi(strtok(limits,":")); 
 bytes_limit=atoi(strtok(NULL,"\n"));

 printf("Your fido address is: %d:%d/%d\n",myfidoaddr.zone,myfidoaddr.net,myfidoaddr.node);
 printf("I am faking the node: %d:%d/%d\n",fakefidoaddr.zone,fakefidoaddr.net,fakefidoaddr.node);
 printf("Your internet address is: %s\n",Emailaddr);
 printf("Your origin: %s\n",originline);
 printf("Limits are set to: %d lines, %d bytes\n",lines_limit,bytes_limit);
 fclose(f);
 strcpy(myNEWSGROUPSFILE,getenv("HOME"));
 strcat(myNEWSGROUPSFILE,"/");
 strcat(myNEWSGROUPSFILE,NEWSGROUPSFILE);
 strcpy(myNEWSSUBJECTSFILE,getenv("HOME"));
 strcat(myNEWSSUBJECTSFILE,"/");
 strcat(myNEWSSUBJECTSFILE,NEWSSUBJECTSFILE);
 sprintf(postpktfile,"%s.pkt",postpktfile);
}

void clean_up()
{
 closefidopacket(writepktfile);
 fprintf(stderr,"program terminated (ctrl-break), packet was closed.\n");
 fprintf(stderr,"recovery file will be used next session.\n");
 exit(1);
}

char *getlastpktname(base)
char *base;
{
 static char filename[100];
 FILE *f;
 int i;

 sprintf(filename,"%s.pkt",base);

 f=fopen(filename,"r");
 if (f==NULL) {
	return filename;
 }
 fclose(f);

 for (i=0; ;i++) {
  sprintf(filename,"%s%d.pkt",base,i);
  f=fopen(filename,"r");
  if (f==NULL) {
	return filename;
  }
  fclose(f);
 }
}

main(argc,argv)
int argc;
char *argv[];
{
 int sock;

 srand((int)time((long*)0));

 readsetup();
 strcpy(writepktfile,getlastpktname(writepktfile));
 printf("Output packet: %s\nInput  packet: %s\n",writepktfile,postpktfile);

 if (recoverfileexists())
 {
  printf("Recover file exists. Will not retrieve articles that were \
already retrieved.\n");
  checkrecover=1;
 }
 else checkrecover=0;

 printf("Connecting to %s...\n",servername);
 sock = Socket(servername,119);
 if (sock==-1)
 {
  perror("creating socket");
  exit(2);
 }
 if (nntp_greet())
 {
  close(sock);
  exit(2);
 }
 
 postpkt(sock,postpktfile);

 openfidopacket(writepktfile);
 
 signal(SIGINT,clean_up); /* close packet when interrupting */

 if (argc>1) 
   if (!strcmp(*++argv,"-l")) nntp_listgroups(sock);

 nntp_scangroups(sock);

 closefidopacket(writepktfile);

 unlink(RECOVERFILE);

 close(sock);
 exit(0);
}
